﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Tasks
{
    class Program
    {
        static void DoIt()
        {
            int ctr = 0;
            for (ctr = 0; ctr < 1000000000; ctr++) { }
            Console.WriteLine("Finished {0} loop iterations.", ctr);
        }
        static void Example1()
        {
            Task t = Task.Run((Action)DoIt);
            t.Wait();
            Console.WriteLine("All Done");
        }
        static void Example2()
        {
            // Wait on a single task with no timeout specified.
            Task taskA = Task.Run(() => Thread.Sleep(2000));
            Console.WriteLine("taskA Status: {0}", taskA.Status);
            Thread.Sleep(250);
            Console.WriteLine("taskA Status: {0}", taskA.Status);
            try
            {
                taskA.Wait();
                Console.WriteLine("taskA Status: {0}", taskA.Status);
            }
            catch (AggregateException)
            {
                Console.WriteLine("Exception in taskA.");
            }
        }
        static void Example3()
        {
            Task<int> t = Task<int>.Run(() => {
                // Just loop.
                int max = 250000000;
                int ctr = 0;
                for (ctr = 0; ctr < max; ctr++)
                {
                    if (ctr == max / 2 && DateTime.Now.Hour <= 12)
                    {
                        break;
                    }
                }
                return ctr;
            });
            Console.WriteLine("Main thread comment while thread working.");
            Console.WriteLine("Finished {0:N0} iterations.", t.Result);
            Console.WriteLine("Main thread comment after blocking on t.Result");
        }
        static void Main(string[] args)
        {
            Example3();
            Console.WriteLine("Hit Enter...");
            Console.ReadLine();
        }
    }
}
